/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type ReadonlySignerAccount, type ReadonlyUint8Array, type TransactionSigner, type WritableAccount } from '@solana/web3.js';
import { TENSOR_WHITELIST_PROGRAM_ADDRESS } from '../programs';
export declare const CLOSE_WHITELIST_V2_DISCRIMINATOR: Uint8Array;
export declare function getCloseWhitelistV2DiscriminatorBytes(): ReadonlyUint8Array;
export type CloseWhitelistV2Instruction<TProgram extends string = typeof TENSOR_WHITELIST_PROGRAM_ADDRESS, TAccountRentDestination extends string | IAccountMeta<string> = string, TAccountUpdateAuthority extends string | IAccountMeta<string> = string, TAccountWhitelist extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountRentDestination extends string ? WritableAccount<TAccountRentDestination> : TAccountRentDestination,
    TAccountUpdateAuthority extends string ? ReadonlySignerAccount<TAccountUpdateAuthority> & IAccountSignerMeta<TAccountUpdateAuthority> : TAccountUpdateAuthority,
    TAccountWhitelist extends string ? WritableAccount<TAccountWhitelist> : TAccountWhitelist,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    ...TRemainingAccounts
]>;
export type CloseWhitelistV2InstructionData = {
    discriminator: ReadonlyUint8Array;
};
export type CloseWhitelistV2InstructionDataArgs = {};
export declare function getCloseWhitelistV2InstructionDataEncoder(): Encoder<CloseWhitelistV2InstructionDataArgs>;
export declare function getCloseWhitelistV2InstructionDataDecoder(): Decoder<CloseWhitelistV2InstructionData>;
export declare function getCloseWhitelistV2InstructionDataCodec(): Codec<CloseWhitelistV2InstructionDataArgs, CloseWhitelistV2InstructionData>;
export type CloseWhitelistV2Input<TAccountRentDestination extends string = string, TAccountUpdateAuthority extends string = string, TAccountWhitelist extends string = string, TAccountSystemProgram extends string = string> = {
    /** The rent payer. */
    rentDestination: Address<TAccountRentDestination>;
    /** The authority that will be allowed to update the whitelist. */
    updateAuthority: TransactionSigner<TAccountUpdateAuthority>;
    /** The whitelist PDA. */
    whitelist: Address<TAccountWhitelist>;
    systemProgram?: Address<TAccountSystemProgram>;
};
export declare function getCloseWhitelistV2Instruction<TAccountRentDestination extends string, TAccountUpdateAuthority extends string, TAccountWhitelist extends string, TAccountSystemProgram extends string, TProgramAddress extends Address = typeof TENSOR_WHITELIST_PROGRAM_ADDRESS>(input: CloseWhitelistV2Input<TAccountRentDestination, TAccountUpdateAuthority, TAccountWhitelist, TAccountSystemProgram>, config?: {
    programAddress?: TProgramAddress;
}): CloseWhitelistV2Instruction<TProgramAddress, TAccountRentDestination, TAccountUpdateAuthority, TAccountWhitelist, TAccountSystemProgram>;
export type ParsedCloseWhitelistV2Instruction<TProgram extends string = typeof TENSOR_WHITELIST_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** The rent payer. */
        rentDestination: TAccountMetas[0];
        /** The authority that will be allowed to update the whitelist. */
        updateAuthority: TAccountMetas[1];
        /** The whitelist PDA. */
        whitelist: TAccountMetas[2];
        systemProgram: TAccountMetas[3];
    };
    data: CloseWhitelistV2InstructionData;
};
export declare function parseCloseWhitelistV2Instruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedCloseWhitelistV2Instruction<TProgram, TAccountMetas>;
//# sourceMappingURL=closeWhitelistV2.d.ts.map