/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type ReadonlyUint8Array, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { TENSOR_WHITELIST_PROGRAM_ADDRESS } from '../programs';
export declare const INIT_UPDATE_MINT_PROOF_DISCRIMINATOR: Uint8Array;
export declare function getInitUpdateMintProofDiscriminatorBytes(): ReadonlyUint8Array;
export type InitUpdateMintProofInstruction<TProgram extends string = typeof TENSOR_WHITELIST_PROGRAM_ADDRESS, TAccountWhitelist extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TAccountMintProof extends string | IAccountMeta<string> = string, TAccountUser extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountWhitelist extends string ? ReadonlyAccount<TAccountWhitelist> : TAccountWhitelist,
    TAccountMint extends string ? ReadonlyAccount<TAccountMint> : TAccountMint,
    TAccountMintProof extends string ? WritableAccount<TAccountMintProof> : TAccountMintProof,
    TAccountUser extends string ? WritableSignerAccount<TAccountUser> & IAccountSignerMeta<TAccountUser> : TAccountUser,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    ...TRemainingAccounts
]>;
export type InitUpdateMintProofInstructionData = {
    discriminator: ReadonlyUint8Array;
    proof: Array<ReadonlyUint8Array>;
};
export type InitUpdateMintProofInstructionDataArgs = {
    proof: Array<ReadonlyUint8Array>;
};
export declare function getInitUpdateMintProofInstructionDataEncoder(): Encoder<InitUpdateMintProofInstructionDataArgs>;
export declare function getInitUpdateMintProofInstructionDataDecoder(): Decoder<InitUpdateMintProofInstructionData>;
export declare function getInitUpdateMintProofInstructionDataCodec(): Codec<InitUpdateMintProofInstructionDataArgs, InitUpdateMintProofInstructionData>;
export type InitUpdateMintProofAsyncInput<TAccountWhitelist extends string = string, TAccountMint extends string = string, TAccountMintProof extends string = string, TAccountUser extends string = string, TAccountSystemProgram extends string = string> = {
    whitelist: Address<TAccountWhitelist>;
    mint: Address<TAccountMint>;
    mintProof?: Address<TAccountMintProof>;
    user: TransactionSigner<TAccountUser>;
    systemProgram?: Address<TAccountSystemProgram>;
    proof: InitUpdateMintProofInstructionDataArgs['proof'];
};
export declare function getInitUpdateMintProofInstructionAsync<TAccountWhitelist extends string, TAccountMint extends string, TAccountMintProof extends string, TAccountUser extends string, TAccountSystemProgram extends string, TProgramAddress extends Address = typeof TENSOR_WHITELIST_PROGRAM_ADDRESS>(input: InitUpdateMintProofAsyncInput<TAccountWhitelist, TAccountMint, TAccountMintProof, TAccountUser, TAccountSystemProgram>, config?: {
    programAddress?: TProgramAddress;
}): Promise<InitUpdateMintProofInstruction<TProgramAddress, TAccountWhitelist, TAccountMint, TAccountMintProof, TAccountUser, TAccountSystemProgram>>;
export type InitUpdateMintProofInput<TAccountWhitelist extends string = string, TAccountMint extends string = string, TAccountMintProof extends string = string, TAccountUser extends string = string, TAccountSystemProgram extends string = string> = {
    whitelist: Address<TAccountWhitelist>;
    mint: Address<TAccountMint>;
    mintProof: Address<TAccountMintProof>;
    user: TransactionSigner<TAccountUser>;
    systemProgram?: Address<TAccountSystemProgram>;
    proof: InitUpdateMintProofInstructionDataArgs['proof'];
};
export declare function getInitUpdateMintProofInstruction<TAccountWhitelist extends string, TAccountMint extends string, TAccountMintProof extends string, TAccountUser extends string, TAccountSystemProgram extends string, TProgramAddress extends Address = typeof TENSOR_WHITELIST_PROGRAM_ADDRESS>(input: InitUpdateMintProofInput<TAccountWhitelist, TAccountMint, TAccountMintProof, TAccountUser, TAccountSystemProgram>, config?: {
    programAddress?: TProgramAddress;
}): InitUpdateMintProofInstruction<TProgramAddress, TAccountWhitelist, TAccountMint, TAccountMintProof, TAccountUser, TAccountSystemProgram>;
export type ParsedInitUpdateMintProofInstruction<TProgram extends string = typeof TENSOR_WHITELIST_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        whitelist: TAccountMetas[0];
        mint: TAccountMetas[1];
        mintProof: TAccountMetas[2];
        user: TAccountMetas[3];
        systemProgram: TAccountMetas[4];
    };
    data: InitUpdateMintProofInstructionData;
};
export declare function parseInitUpdateMintProofInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedInitUpdateMintProofInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=initUpdateMintProof.d.ts.map