/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type ReadonlyUint8Array, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { TENSOR_WHITELIST_PROGRAM_ADDRESS } from '../programs';
export declare const UNFREEZE_WHITELIST_DISCRIMINATOR: Uint8Array;
export declare function getUnfreezeWhitelistDiscriminatorBytes(): ReadonlyUint8Array;
export type UnfreezeWhitelistInstruction<TProgram extends string = typeof TENSOR_WHITELIST_PROGRAM_ADDRESS, TAccountWhitelist extends string | IAccountMeta<string> = string, TAccountWhitelistAuthority extends string | IAccountMeta<string> = string, TAccountOwner extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountWhitelist extends string ? WritableAccount<TAccountWhitelist> : TAccountWhitelist,
    TAccountWhitelistAuthority extends string ? ReadonlyAccount<TAccountWhitelistAuthority> : TAccountWhitelistAuthority,
    TAccountOwner extends string ? WritableSignerAccount<TAccountOwner> & IAccountSignerMeta<TAccountOwner> : TAccountOwner,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    ...TRemainingAccounts
]>;
export type UnfreezeWhitelistInstructionData = {
    discriminator: ReadonlyUint8Array;
};
export type UnfreezeWhitelistInstructionDataArgs = {};
export declare function getUnfreezeWhitelistInstructionDataEncoder(): Encoder<UnfreezeWhitelistInstructionDataArgs>;
export declare function getUnfreezeWhitelistInstructionDataDecoder(): Decoder<UnfreezeWhitelistInstructionData>;
export declare function getUnfreezeWhitelistInstructionDataCodec(): Codec<UnfreezeWhitelistInstructionDataArgs, UnfreezeWhitelistInstructionData>;
export type UnfreezeWhitelistAsyncInput<TAccountWhitelist extends string = string, TAccountWhitelistAuthority extends string = string, TAccountOwner extends string = string, TAccountSystemProgram extends string = string> = {
    whitelist: Address<TAccountWhitelist>;
    /**
     * there can only be 1 whitelist authority (due to seeds),
     * and we're checking that 1)the correct cosigner is present on it, and 2)is a signer
     */
    whitelistAuthority?: Address<TAccountWhitelistAuthority>;
    /** unfreezing requires owner */
    owner: TransactionSigner<TAccountOwner>;
    systemProgram?: Address<TAccountSystemProgram>;
};
export declare function getUnfreezeWhitelistInstructionAsync<TAccountWhitelist extends string, TAccountWhitelistAuthority extends string, TAccountOwner extends string, TAccountSystemProgram extends string, TProgramAddress extends Address = typeof TENSOR_WHITELIST_PROGRAM_ADDRESS>(input: UnfreezeWhitelistAsyncInput<TAccountWhitelist, TAccountWhitelistAuthority, TAccountOwner, TAccountSystemProgram>, config?: {
    programAddress?: TProgramAddress;
}): Promise<UnfreezeWhitelistInstruction<TProgramAddress, TAccountWhitelist, TAccountWhitelistAuthority, TAccountOwner, TAccountSystemProgram>>;
export type UnfreezeWhitelistInput<TAccountWhitelist extends string = string, TAccountWhitelistAuthority extends string = string, TAccountOwner extends string = string, TAccountSystemProgram extends string = string> = {
    whitelist: Address<TAccountWhitelist>;
    /**
     * there can only be 1 whitelist authority (due to seeds),
     * and we're checking that 1)the correct cosigner is present on it, and 2)is a signer
     */
    whitelistAuthority: Address<TAccountWhitelistAuthority>;
    /** unfreezing requires owner */
    owner: TransactionSigner<TAccountOwner>;
    systemProgram?: Address<TAccountSystemProgram>;
};
export declare function getUnfreezeWhitelistInstruction<TAccountWhitelist extends string, TAccountWhitelistAuthority extends string, TAccountOwner extends string, TAccountSystemProgram extends string, TProgramAddress extends Address = typeof TENSOR_WHITELIST_PROGRAM_ADDRESS>(input: UnfreezeWhitelistInput<TAccountWhitelist, TAccountWhitelistAuthority, TAccountOwner, TAccountSystemProgram>, config?: {
    programAddress?: TProgramAddress;
}): UnfreezeWhitelistInstruction<TProgramAddress, TAccountWhitelist, TAccountWhitelistAuthority, TAccountOwner, TAccountSystemProgram>;
export type ParsedUnfreezeWhitelistInstruction<TProgram extends string = typeof TENSOR_WHITELIST_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        whitelist: TAccountMetas[0];
        /**
         * there can only be 1 whitelist authority (due to seeds),
         * and we're checking that 1)the correct cosigner is present on it, and 2)is a signer
         */
        whitelistAuthority: TAccountMetas[1];
        /** unfreezing requires owner */
        owner: TAccountMetas[2];
        systemProgram: TAccountMetas[3];
    };
    data: UnfreezeWhitelistInstructionData;
};
export declare function parseUnfreezeWhitelistInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedUnfreezeWhitelistInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=unfreezeWhitelist.d.ts.map